import type { BinaryOp } from '../ot-binary-irreversible/types';
import type { EDIT_TYPE } from './constants';
import type { Expr } from '../../../json-expression';
import type { Path } from '../../../json-pointer';
import type { StringOp } from '../ot-string-irreversible/types';
export declare type JsonOpTestComponent = Expr;
export declare type JsonOpPickComponent = [register: number, path: Path];
export declare type JsonOpDataComponent = [register: number, data: unknown];
export declare type JsonOpDropComponent = [register: number, path: Path];
export declare type JsonOpEditComponent = JsonOpEditComponentOtString | JsonOpEditComponentOtBinary;
export declare type JsonOpEditComponentOtString = [type: EDIT_TYPE.OT_STRING, path: Path, operation: StringOp];
export declare type JsonOpEditComponentOtBinary = [type: EDIT_TYPE.OT_BINARY, path: Path, operation: BinaryOp];
export declare type JsonOp = [
    test: JsonOpTestComponent[],
    pick?: JsonOpPickComponent[],
    data?: JsonOpDataComponent[],
    drop?: JsonOpDropComponent[],
    edit?: JsonOpEditComponent[]
];
