import { ApiPath, NodeApi } from './nodes';
import { Patch } from '../../../json-crdt-patch/Patch';
import { PatchBuilder } from '../../../json-crdt-patch/PatchBuilder';
import type { Model } from '../Model';
export declare class ModelApi {
    readonly model: Model;
    builder: PatchBuilder;
    next: number;
    constructor(model: Model);
    get node(): NodeApi<import("../../types").JsonNode, unknown>;
    get r(): NodeApi<import("../../types/lww-root/RootLww").RootLww, unknown>;
    find(path?: ApiPath): import("../../types").JsonNode;
    val(path?: ApiPath): import("./nodes").ValueApi;
    str(path?: ApiPath): import("./nodes").StringApi;
    bin(path?: ApiPath): import("./nodes").BinaryApi;
    arr(path?: ApiPath): import("./nodes").ArrayApi;
    obj(path?: ApiPath): import("./nodes").ObjectApi;
    const(path?: ApiPath): import("./nodes").ConstApi;
    root(json: unknown): this;
    apply(): void;
    advance(): void;
    view(): unknown;
    flush(): Patch;
}
