import { sort } from '../util/sort';
const hashStr__ = (state, str) => {
    let i = str.length;
    while (i)
        state = (state * 33) ^ str.charCodeAt(--i);
    return state;
};
const hash__ = (state, json) => {
    switch (typeof json) {
        case 'number':
            return (state * 33) ^ json;
        case 'string':
            return hashStr__((state * 33) ^ 600000, json);
        case 'object': {
            if (json === null)
                return (state * 33) ^ 300000;
            if (json instanceof Array) {
                const length = json.length;
                state = (state * 33) ^ 400000;
                for (let i = 0; i < length; i++)
                    state = hash__(state, json[i]);
                return state;
            }
            state = (state * 33) ^ 500000;
            const keys = sort(Object.keys(json));
            const length = keys.length;
            for (let i = 0; i < length; i++) {
                const key = keys[i];
                state = hashStr__(state, key);
                state = hash__(state, json[key]);
            }
            return state;
        }
        case 'boolean':
            return (state * 33) ^ (json ? 100000 : 200000);
    }
    return state;
};
export const hash = (json) => hash__(5381, json) >>> 0;
