import { getHeaderSize } from '../../codec/binary/header';
import { ResponseErrorMessage } from '../nominal';
export class BinaryResponseErrorMessage extends ResponseErrorMessage {
    size() {
        const dataSize = this.data.byteLength;
        return getHeaderSize(dataSize) + 2 + dataSize;
    }
    writeCompact(encoder) {
        const data = this.data;
        encoder.encodeArrayHeader(3);
        encoder.u32(-1);
        encoder.u32(this.id);
        encoder.writer.buf(data, data.byteLength);
    }
}
