"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.find = void 0;
var ArrayRga_1 = require("../../types/rga-array/ArrayRga");
var ObjectLww_1 = require("../../types/lww-object/ObjectLww");
var json_pointer_1 = require("../../../json-pointer");
var find = function (startNode, path) {
    var steps = (0, json_pointer_1.toPath)(path);
    var node = startNode;
    var length = steps.length;
    if (!length)
        return node;
    var i = 0;
    while (i < length && node) {
        var step = steps[i++];
        node = node.container();
        if (!node)
            throw new Error('NOT_CONTAINER');
        if (node instanceof ObjectLww_1.ObjectLww) {
            var nextNode = node.get(String(step));
            if (!nextNode)
                throw new Error('NOT_FOUND');
            node = nextNode;
        }
        else if (node instanceof ArrayRga_1.ArrayRga) {
            var nextNode = node.getNode(Number(step));
            if (!nextNode)
                throw new Error('NOT_FOUND');
            node = nextNode;
        }
    }
    return node;
};
exports.find = find;
