"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.apply = void 0;
var apply = function (val, op) {
    var length = op.length;
    var offset = 0;
    var res = [];
    var outputLength = 0;
    for (var i = 0; i < length; i++) {
        var component = op[i];
        switch (typeof component) {
            case 'object':
                res.push(component);
                outputLength += component.length;
                break;
            case 'number': {
                if (component > 0) {
                    var end = offset + component;
                    res.push(val.subarray(offset, end));
                    outputLength += end - offset;
                    offset = end;
                }
                else
                    offset -= component;
                break;
            }
        }
    }
    res.push(val.subarray(offset));
    outputLength += val.length - offset;
    var output = new Uint8Array(outputLength);
    var resLength = res.length;
    for (var i = 0, j = 0; i < resLength; i++) {
        var component = res[i];
        output.set(component, j);
        j += component.length;
    }
    return output;
};
exports.apply = apply;
