"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.compose = void 0;
var util_1 = require("./util");
var compose = function (op1, op2) {
    var op3 = [];
    var len1 = op1.length;
    var len2 = op2.length;
    var off1 = 0;
    var i1 = 0;
    for (var i2 = 0; i2 < len2; i2++) {
        var comp2 = op2[i2];
        if (typeof comp2 === 'number') {
            if (comp2 > 0) {
                var length2 = comp2;
                while (length2 > 0) {
                    var comp1 = op1[i1];
                    var comp = i1 >= len1 ? length2 : (0, util_1.chunk)(comp1, off1, length2);
                    var compLength = (0, util_1.componentLength)(comp);
                    var isDelete = (0, util_1.isDeleteComponent)(comp);
                    var length1 = (0, util_1.componentLength)(comp1 || comp);
                    (0, util_1.append)(op3, comp);
                    off1 += compLength;
                    if (off1 >= length1) {
                        i1++;
                        off1 = 0;
                    }
                    if (!isDelete)
                        length2 -= compLength;
                }
            }
            else {
                var length2 = -comp2;
                var off2 = 0;
                while (off2 < length2) {
                    var remaining = length2 - off2;
                    var comp1 = op1[i1];
                    var comp = i1 >= len1 ? remaining : (0, util_1.chunk)(comp1, off1, remaining);
                    var compLength = (0, util_1.componentLength)(comp);
                    var isDelete = (0, util_1.isDeleteComponent)(comp);
                    var length1 = (0, util_1.componentLength)(comp1 || comp);
                    if (isDelete)
                        (0, util_1.append)(op3, comp);
                    else if (typeof comp === 'number')
                        (0, util_1.append)(op3, -compLength);
                    off1 += compLength;
                    if (off1 >= length1) {
                        i1++;
                        off1 = 0;
                    }
                    if (!isDelete)
                        off2 += compLength;
                }
            }
        }
        else if (comp2 instanceof Uint8Array) {
            (0, util_1.append)(op3, comp2);
        }
    }
    if (i1 < len1 && off1)
        (0, util_1.append)(op3, (0, util_1.chunk)(op1[i1++], off1, Infinity));
    for (; i1 < len1; i1++)
        (0, util_1.append)(op3, op1[i1]);
    (0, util_1.trim)(op3);
    return op3;
};
exports.compose = compose;
