"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.validate = void 0;
var validate = function (op) {
    if (!(op instanceof Array))
        return 1;
    if (op.length === 0)
        return 1;
    var last;
    for (var i = 0; i < op.length; i++) {
        var component = op[i];
        if (typeof component === 'number') {
            if (!component)
                return 2;
            if (component !== Math.round(component))
                return 2;
            if (component > 0) {
                var lastComponentIsRetain = typeof last === 'number' && last > 0;
                if (lastComponentIsRetain)
                    return 3;
            }
            else {
                var lastComponentIsDelete = typeof last === 'number' && last < 0;
                if (lastComponentIsDelete)
                    return 3;
            }
        }
        else if (component instanceof Uint8Array) {
            if (!component.length)
                return 2;
            var lastComponentIsInsert = last instanceof Uint8Array;
            if (lastComponentIsInsert)
                return 3;
        }
        else {
            return 2;
        }
        last = component;
    }
    var isLastRetain = typeof last === 'number' && last > 0;
    if (isLastRetain)
        return 4;
    return 0;
};
exports.validate = validate;
