"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.apply = void 0;
var tslib_1 = require("tslib");
var json_pointer_1 = require("../../../json-pointer");
var evaluate_1 = require("../../../json-expression/evaluate");
var util_1 = require("./util");
var apply_1 = require("../ot-string-irreversible/apply");
var apply_2 = require("../ot-binary-irreversible/apply");
var apply = function (doc, op) {
    var e_1, _a, e_2, _b, e_3, _c, e_4, _d;
    var _e = tslib_1.__read(op, 5), test = _e[0], _f = _e[1], pick = _f === void 0 ? [] : _f, _g = _e[2], data = _g === void 0 ? [] : _g, _h = _e[3], drop = _h === void 0 ? [] : _h, _j = _e[4], edit = _j === void 0 ? [] : _j;
    var testLength = test.length;
    if (testLength) {
        var expressionContext = { data: doc };
        for (var i = 0; i < testLength; i++) {
            var testExpr = test[i];
            var testValue = (0, evaluate_1.evaluate)(testExpr, expressionContext);
            if (!testValue)
                throw new Error('TEST');
        }
    }
    var registers = new Map();
    var picksSorted = pick.sort(function (a, b) { return (0, util_1.comparePath)(a[1], b[1]); });
    try {
        for (var picksSorted_1 = tslib_1.__values(picksSorted), picksSorted_1_1 = picksSorted_1.next(); !picksSorted_1_1.done; picksSorted_1_1 = picksSorted_1.next()) {
            var _k = tslib_1.__read(picksSorted_1_1.value, 2), regId = _k[0], path = _k[1];
            var ref = (0, json_pointer_1.find)(doc, path);
            if ((0, json_pointer_1.isArrayReference)(ref)) {
                var obj = ref.obj, key = ref.key, val = ref.val;
                obj.splice(key, 1);
                registers.set(regId, val);
            }
            else if ((0, json_pointer_1.isObjectReference)(ref)) {
                var obj = ref.obj, key = ref.key, val = ref.val;
                delete obj[key];
                registers.set(regId, val);
            }
            else {
                doc = undefined;
                registers.set(regId, ref.val);
            }
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (picksSorted_1_1 && !picksSorted_1_1.done && (_a = picksSorted_1.return)) _a.call(picksSorted_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    try {
        for (var data_1 = tslib_1.__values(data), data_1_1 = data_1.next(); !data_1_1.done; data_1_1 = data_1.next()) {
            var _l = tslib_1.__read(data_1_1.value, 2), regId = _l[0], value = _l[1];
            registers.set(regId, value);
        }
    }
    catch (e_2_1) { e_2 = { error: e_2_1 }; }
    finally {
        try {
            if (data_1_1 && !data_1_1.done && (_b = data_1.return)) _b.call(data_1);
        }
        finally { if (e_2) throw e_2.error; }
    }
    var dropsSorted = drop.sort(function (a, b) { return (0, util_1.comparePath)(b[1], a[1]); });
    try {
        for (var dropsSorted_1 = tslib_1.__values(dropsSorted), dropsSorted_1_1 = dropsSorted_1.next(); !dropsSorted_1_1.done; dropsSorted_1_1 = dropsSorted_1.next()) {
            var _m = tslib_1.__read(dropsSorted_1_1.value, 2), regId = _m[0], where = _m[1];
            var value = registers.get(regId);
            if (!where.length) {
                doc = value;
                continue;
            }
            var path = where.slice(0, -1);
            var val = (0, json_pointer_1.find)(doc, path).val;
            if (val instanceof Array) {
                var index = where[where.length - 1];
                if (index === '-')
                    index = val.length;
                var index2 = ~~index;
                if (typeof index === 'string')
                    if ('' + index2 !== index)
                        throw new Error('INVALID_INDEX');
                if (index2 > val.length || index2 < -1)
                    throw new Error('INVALID_INDEX');
                if (index2 === -1 || index2 === val.length)
                    val.push(value);
                else
                    val.splice(index2, 0, value);
            }
            else if (val && typeof val === 'object') {
                var key = where[where.length - 1];
                val[key] = value;
            }
            else {
                throw new Error('NOT_FOUND');
            }
        }
    }
    catch (e_3_1) { e_3 = { error: e_3_1 }; }
    finally {
        try {
            if (dropsSorted_1_1 && !dropsSorted_1_1.done && (_c = dropsSorted_1.return)) _c.call(dropsSorted_1);
        }
        finally { if (e_3) throw e_3.error; }
    }
    try {
        for (var edit_1 = tslib_1.__values(edit), edit_1_1 = edit_1.next(); !edit_1_1.done; edit_1_1 = edit_1.next()) {
            var _o = tslib_1.__read(edit_1_1.value, 3), type = _o[0], path = _o[1], operation = _o[2];
            var _p = (0, json_pointer_1.find)(doc, path), val = _p.val, obj = _p.obj, key = _p.key;
            var newVal = void 0;
            switch (type) {
                case 0: {
                    if (typeof val !== 'string')
                        throw new Error('NOT_STR');
                    newVal = (0, apply_1.apply)(val, operation);
                    break;
                }
                case 1: {
                    if (!(val instanceof Uint8Array))
                        throw new Error('NOT_BIN');
                    newVal = (0, apply_2.apply)(val, operation);
                    break;
                }
            }
            if (!obj)
                doc = newVal;
            else
                obj[key] = newVal;
        }
    }
    catch (e_4_1) { e_4 = { error: e_4_1 }; }
    finally {
        try {
            if (edit_1_1 && !edit_1_1.done && (_d = edit_1.return)) _d.call(edit_1);
        }
        finally { if (e_4) throw e_4.error; }
    }
    return doc;
};
exports.apply = apply;
