"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.toJsonOp = exports.jsonPatchOpToJsonOp = void 0;
var tslib_1 = require("tslib");
var util_1 = require("../../../json-expression/util");
var tree_1 = require("./tree");
var util_2 = require("../../../json-pointer/util");
var jsonPatchOpToJsonOp = function (operation) {
    var op = operation.op;
    switch (op) {
        case 'test': {
            var value = (0, util_1.literal)(operation.value);
            var expression = [operation.not ? '!=' : '==', ['=', operation.path], value];
            return [[expression]];
        }
        case 'add': {
            return [[], [], [[0, operation.value]], [[0, (0, util_2.toPath)(operation.path)]]];
        }
        case 'remove': {
            var path = (0, util_2.toPath)(operation.path);
            return [[['defined', operation.path]], [[0, path]]];
        }
        case 'replace': {
            var path = (0, util_2.toPath)(operation.path);
            var test_1 = path.length ? [['defined', operation.path]] : [];
            return [test_1, [[0, path]], [[1, operation.value]], [[1, path]]];
        }
        case 'move': {
            var path = (0, util_2.toPath)(operation.path);
            var from = (0, util_2.toPath)(operation.from);
            var test_2 = from.length ? [['defined', operation.from]] : [];
            return [test_2, [[0, from]], [], [[0, path]]];
        }
        case 'copy': {
            var path = (0, util_2.toPath)(operation.path);
            var from = (0, util_2.toPath)(operation.from);
            return [
                [],
                [[0, from]],
                [],
                [
                    [0, from],
                    [0, path],
                ],
            ];
        }
    }
    return [[]];
};
exports.jsonPatchOpToJsonOp = jsonPatchOpToJsonOp;
var toJsonOp = function (patch) {
    var e_1, _a;
    var tree = tree_1.OpTree.from([[]]);
    try {
        for (var patch_1 = tslib_1.__values(patch), patch_1_1 = patch_1.next(); !patch_1_1.done; patch_1_1 = patch_1.next()) {
            var op = patch_1_1.value;
            var otOp = (0, exports.jsonPatchOpToJsonOp)(op);
            var opTree = tree_1.OpTree.from(otOp);
            tree.compose(opTree);
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (patch_1_1 && !patch_1_1.done && (_a = patch_1.return)) _a.call(patch_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return tree.toJson();
};
exports.toJsonOp = toJsonOp;
